/*+ Util.h
 *
 ******************************************************************************
 *
 *                        Trimble Navigation Limited
 *                           645 North Mary Avenue
 *                              P.O. Box 3642
 *                         Sunnyvale, CA 94088-3642
 *
 ******************************************************************************
 *
 *    Copyright  2005 Trimble Navigation Ltd.
 *    All Rights Reserved
 *
 ******************************************************************************
 *
 * Description:
 *    Interface for the CUtil class.
 *            
 * Revision History:
 *    09-22-2005    Mike Priven
 *                  Cleaned up and adapted for outside distribution.
 *
 *    xx-xx-2001    Sean Zhi
 *                  Original
 *
 * Notes:
 *
-*/

#ifndef UTIL_H
#define UTIL_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define	GET_BYTE_3(x) ((unsigned char) ((0xff000000L & x) >> 24))
#define	GET_BYTE_2(x) ((unsigned char) ((0x00ff0000L & x) >> 16))
#define	GET_BYTE_1(x) ((unsigned char) ((0x0000ff00L & x) >> 8))
#define	GET_BYTE_0(x) ((unsigned char) (0x000000ffL & x))

/*---------------------------------------------------------------------------*\
 |                      C L A S S   D E F I N I T I O N
\*---------------------------------------------------------------------------*/
class CUtil  
{
    
public: //==== P U B L I C   M E T H O D S ===================================/
    
    static long  LoadSrecFile      (FILE*, unsigned char*, unsigned long);
    static long  LoadSrecStr       (char*, unsigned char*, unsigned long);
    static short GetEnqPkt         (char*);
    static short GetFwErasePkt     (char*);
    static short GetFwProgramPkt   (char*, char*, short, unsigned long);
    static short GetDemonProgramPkt(char*, char*, short, unsigned long);
    static short GetStartDemonPkt  (char*);
    static short GetForce2MonPkt   (char*);
    static short GetDemonSetPortPkt(char*, unsigned long);
    
    
private: //==== P R I V A T E   M E T H O D S ================================/
    
    static short         CheckSrecCsum   (char*);
    static unsigned long GetSrecAddr     (char*);
    static long          GetSrecDataSize (FILE*);
    static long          GetSrecStrSize  (char *);

};

#endif // UTIL_H
